diff -Naur --no-dereference a/drivers/gpu/drm/tidss/tidss_scale_coefs.c b/drivers/gpu/drm/tidss/tidss_scale_coefs.c
--- a/drivers/gpu/drm/tidss/tidss_scale_coefs.c	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/gpu/drm/tidss/tidss_scale_coefs.c	2020-06-19 21:00:31.412227715 -0400
@@ -0,0 +1,178 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * Copyright (C) 2018 Texas Instruments Incorporated - http://www.ti.com/
+ * Author: Jyri Sarha <jsarha@ti.com>
+ */
+
+#include <linux/kernel.h>
+#include <linux/device.h>
+#include "tidss_scale_coefs.h"
+
+/*
+ * These are interpolated with a custom python script from DSS5
+ * (drivers/gpu/drm/omapdrm/dss/dispc_coef.c) coefficients.
+ */
+static const struct tidss_scale_coefs coef5_M32 = {
+	.c2 = { 28, 34, 40, 46, 52, 58, 64, 70, 0, 2, 4, 8, 12, 16, 20, 24, },
+	.c1 = { 132, 138, 144, 150, 156, 162, 168, 174, 76, 84, 92, 98, 104, 110, 116, 124, },
+	.c0 = { 192, 192, 192, 190, 188, 186, 184, 182, 180, },
+};
+static const struct tidss_scale_coefs coef5_M26 = {
+	.c2 = { 24, 28, 32, 38, 44, 50, 56, 64, 0, 2, 4, 6, 8, 12, 16, 20, },
+	.c1 = { 132, 138, 144, 152, 160, 166, 172, 178, 72, 80, 88, 94, 100, 108, 116, 124, },
+	.c0 = { 200, 202, 204, 202, 200, 196, 192, 188, 184, },
+};
+static const struct tidss_scale_coefs coef5_M22 = {
+	.c2 = { 16, 20, 24, 30, 36, 42, 48, 56, 0, 0, 0, 2, 4, 8, 12, 14, },
+	.c1 = { 132, 140, 148, 156, 164, 172, 180, 186, 64, 72, 80, 88, 96, 104, 112, 122, },
+	.c0 = { 216, 216, 216, 214, 212, 208, 204, 198, 192, },
+};
+static const struct tidss_scale_coefs coef5_M19 = {
+	.c2 = { 12, 14, 16, 22, 28, 34, 40, 48, 0, 0, 0, 2, 4, 4, 4, 8, },
+	.c1 = { 128, 140, 152, 160, 168, 176, 184, 192, 56, 64, 72, 82, 92, 100, 108, 118, },
+	.c0 = { 232, 232, 232, 226, 220, 218, 216, 208, 200, },
+};
+static const struct tidss_scale_coefs coef5_M16 = {
+	.c2 = { 0, 2, 4, 8, 12, 18, 24, 32, 0, 0, 0, -2, -4, -4, -4, -2, },
+	.c1 = { 124, 138, 152, 164, 176, 186, 196, 206, 40, 48, 56, 68, 80, 90, 100, 112, },
+	.c0 = { 264, 262, 260, 254, 248, 242, 236, 226, 216, },
+};
+static const struct tidss_scale_coefs coef5_M14 = {
+	.c2 = { -8, -6, -4, -2, 0, 6, 12, 18, 0, -2, -4, -6, -8, -8, -8, -8, },
+	.c1 = { 120, 134, 148, 164, 180, 194, 208, 220, 24, 32, 40, 52, 64, 78, 92, 106, },
+	.c0 = { 288, 286, 284, 280, 276, 266, 256, 244, 232, },
+};
+static const struct tidss_scale_coefs coef5_M13 = {
+	.c2 = { -12, -12, -12, -10, -8, -4, 0, 6, 0, -2, -4, -6, -8, -10, -12, -12, },
+	.c1 = { 112, 130, 148, 164, 180, 196, 212, 228, 12, 22, 32, 44, 56, 70, 84, 98, },
+	.c0 = { 312, 308, 304, 298, 292, 282, 272, 258, 244, },
+};
+static const struct tidss_scale_coefs coef5_M12 = {
+	.c2 = { -16, -18, -20, -18, -16, -14, -12, -6, 0, -2, -4, -6, -8, -10, -12, -14, },
+	.c1 = { 104, 124, 144, 164, 184, 202, 220, 238, 0, 10, 20, 30, 40, 56, 72, 88, },
+	.c0 = { 336, 332, 328, 320, 312, 300, 288, 272, 256, },
+};
+static const struct tidss_scale_coefs coef5_M11 = {
+	.c2 = { -20, -22, -24, -24, -24, -24, -24, -20, 0, -2, -4, -6, -8, -10, -12, -16, },
+	.c1 = { 92, 114, 136, 158, 180, 204, 228, 250, -16, -8, 0, 12, 24, 38, 52, 72, },
+	.c0 = { 368, 364, 360, 350, 340, 326, 312, 292, 272, },
+};
+static const struct tidss_scale_coefs coef5_M10 = {
+	.c2 = { -16, -20, -24, -28, -32, -34, -36, -34, 0, 0, 0, -2, -4, -8, -12, -14, },
+	.c1 = { 72, 96, 120, 148, 176, 204, 232, 260, -32, -26, -20, -10, 0, 16, 32, 52, },
+	.c0 = { 400, 398, 396, 384, 372, 354, 336, 312, 288, },
+};
+static const struct tidss_scale_coefs coef5_M9 = {
+	.c2 = { -12, -18, -24, -28, -32, -38, -44, -46, 0, 2, 4, 2, 0, -2, -4, -8, },
+	.c1 = { 40, 68, 96, 128, 160, 196, 232, 268, -48, -46, -44, -36, -28, -14, 0, 20, },
+	.c0 = { 456, 450, 444, 428, 412, 388, 364, 334, 304, },
+};
+static const struct tidss_scale_coefs coef5_M8 = {
+	.c2 = { 0, -4, -8, -16, -24, -32, -40, -48, 0, 2, 4, 6, 8, 6, 4, 2, },
+	.c1 = { 0, 28, 56, 94, 132, 176, 220, 266, -56, -60, -64, -62, -60, -50, -40, -20, },
+	.c0 = { 512, 506, 500, 478, 456, 424, 392, 352, 312, },
+};
+static const struct tidss_scale_coefs coef3_M32 = {
+	.c1 = { 108, 92, 76, 62, 48, 36, 24, 140, 256, 236, 216, 198, 180, 162, 144, 126, },
+	.c0 = { 296, 294, 292, 288, 284, 278, 272, 136, 256, },
+};
+static const struct tidss_scale_coefs coef3_M26 = {
+	.c1 = { 104, 90, 76, 60, 44, 32, 20, 138, 256, 236, 216, 198, 180, 160, 140, 122, },
+	.c0 = { 304, 300, 296, 292, 288, 282, 276, 138, 256, },
+};
+static const struct tidss_scale_coefs coef3_M22 = {
+	.c1 = { 100, 84, 68, 54, 40, 30, 20, 138, 256, 236, 216, 196, 176, 156, 136, 118, },
+	.c0 = { 312, 310, 308, 302, 296, 286, 276, 138, 256, },
+};
+static const struct tidss_scale_coefs coef3_M19 = {
+	.c1 = { 96, 80, 64, 50, 36, 26, 16, 136, 256, 236, 216, 194, 172, 152, 132, 114, },
+	.c0 = { 320, 318, 316, 310, 304, 292, 280, 140, 256, },
+};
+static const struct tidss_scale_coefs coef3_M16 = {
+	.c1 = { 88, 72, 56, 44, 32, 22, 12, 134, 256, 234, 212, 190, 168, 148, 128, 108, },
+	.c0 = { 336, 332, 328, 320, 312, 300, 288, 144, 256, },
+};
+static const struct tidss_scale_coefs coef3_M14 = {
+	.c1 = { 80, 64, 48, 36, 24, 16, 8, 132, 256, 232, 208, 186, 164, 142, 120, 100, },
+	.c0 = { 352, 348, 344, 334, 324, 310, 296, 148, 256, },
+};
+static const struct tidss_scale_coefs coef3_M13 = {
+	.c1 = { 72, 56, 40, 30, 20, 12, 4, 130, 256, 232, 208, 184, 160, 136, 112, 92, },
+	.c0 = { 368, 364, 360, 346, 332, 316, 300, 150, 256, },
+};
+static const struct tidss_scale_coefs coef3_M12 = {
+	.c1 = { 64, 50, 36, 26, 16, 10, 4, 130, 256, 230, 204, 178, 152, 128, 104, 84, },
+	.c0 = { 384, 378, 372, 358, 344, 324, 304, 152, 256, },
+};
+static const struct tidss_scale_coefs coef3_M11 = {
+	.c1 = { 56, 40, 24, 16, 8, 4, 0, 128, 256, 228, 200, 172, 144, 120, 96, 76, },
+	.c0 = { 400, 396, 392, 376, 360, 336, 312, 156, 256, },
+};
+static const struct tidss_scale_coefs coef3_M10 = {
+	.c1 = { 40, 26, 12, 6, 0, -2, -4, 126, 256, 226, 196, 166, 136, 110, 84, 62, },
+	.c0 = { 432, 424, 416, 396, 376, 348, 320, 160, 256, },
+};
+static const struct tidss_scale_coefs coef3_M9 = {
+	.c1 = { 24, 12, 0, -4, -8, -8, -8, 124, 256, 222, 188, 154, 120, 92, 64, 44, },
+	.c0 = { 464, 456, 448, 424, 400, 366, 332, 166, 256, },
+};
+static const struct tidss_scale_coefs coef3_M8 = {
+	.c1 = { 0, -8, -16, -16, -16, -12, -8, 124, 256, 214, 172, 134, 96, 66, 36, 18, },
+	.c0 = { 512, 502, 492, 462, 432, 390, 348, 174, 256, },
+};
+
+const struct tidss_scale_coefs *tidss_get_scale_coefs(struct device *dev,
+						      u32 firinc,
+						      bool five_taps)
+{
+	int i;
+	int inc;
+	static const struct {
+		int Mmin;
+		int Mmax;
+		const struct tidss_scale_coefs *coef3;
+		const struct tidss_scale_coefs *coef5;
+		const char *name;
+	} coefs[] = {
+		{ 27, 32, &coef3_M32, &coef5_M32, "M32" },
+		{ 23, 26, &coef3_M26, &coef5_M26, "M26" },
+		{ 20, 22, &coef3_M22, &coef5_M22, "M22" },
+		{ 17, 19, &coef3_M19, &coef5_M19, "M19" },
+		{ 15, 16, &coef3_M16, &coef5_M16, "M16" },
+		{ 14, 14, &coef3_M14, &coef5_M14, "M14" },
+		{ 13, 13, &coef3_M13, &coef5_M13, "M13" },
+		{ 12, 12, &coef3_M12, &coef5_M12, "M12" },
+		{ 11, 11, &coef3_M11, &coef5_M11, "M11" },
+		{ 10, 10, &coef3_M10, &coef5_M10, "M10" },
+		{  9,  9, &coef3_M9, &coef5_M9, "M9" },
+		{  4,  8, &coef3_M8, &coef5_M8, "M8" },
+		/*
+		 * When upscaling more than two times, blockiness and outlines
+		 * around the image are observed when M8 tables are used. M11,
+		 * M16 and M19 tables are used to prevent this.
+		 */
+		{  3,  3, &coef3_M11, &coef5_M11, "M11" },
+		{  2,  2, &coef3_M16, &coef5_M16, "M16" },
+		{  0,  1, &coef3_M19, &coef5_M19, "M19" },
+	};
+
+	/*
+	 * inc is result of 0x200000 * in_size / out_size. This dividing
+	 * by 0x40000 scales it down to 8 * in_size / out_size. After
+	 * division the actual scaling factor is 8/inc.
+	 */
+	inc = firinc / 0x40000;
+	for (i = 0; i < ARRAY_SIZE(coefs); ++i) {
+		if (inc >= coefs[i].Mmin && inc <= coefs[i].Mmax) {
+			if (five_taps)
+				return coefs[i].coef5;
+			else
+				return coefs[i].coef3;
+		}
+	}
+
+	dev_err(dev, "%s: Coefficients not found for firinc 0x%08x, inc %d\n",
+		__func__, firinc, inc);
+
+	return NULL;
+}
diff -Naur --no-dereference a/drivers/gpu/drm/tidss/tidss_scale_coefs.h b/drivers/gpu/drm/tidss/tidss_scale_coefs.h
--- a/drivers/gpu/drm/tidss/tidss_scale_coefs.h	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/gpu/drm/tidss/tidss_scale_coefs.h	2020-06-19 21:00:31.412227715 -0400
@@ -0,0 +1,22 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+/*
+ * Copyright (C) 2018 Texas Instruments Incorporated - http://www.ti.com/
+ * Author: Jyri Sarha <jsarha@ti.com>
+ */
+
+#ifndef __TIDSS_DISPC_COEF_H__
+#define __TIDSS_DISPC_COEF_H__
+
+#include <linux/types.h>
+
+struct tidss_scale_coefs {
+	s16 c2[16];
+	s16 c1[16];
+	u16 c0[9];
+};
+
+const struct tidss_scale_coefs *tidss_get_scale_coefs(struct device *dev,
+						      u32 firinc,
+						      bool five_taps);
+
+#endif
diff -Naur --no-dereference a/drivers/gpu/drm/tidss/tidss_v_connector.c b/drivers/gpu/drm/tidss/tidss_v_connector.c
--- a/drivers/gpu/drm/tidss/tidss_v_connector.c	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/gpu/drm/tidss/tidss_v_connector.c	2020-06-19 21:00:31.412227715 -0400
@@ -0,0 +1,144 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * Copyright (C) 2018 Texas Instruments Incorporated - http://www.ti.com/
+ * Author: Subhajit Paul <subhajit_paul@ti.com>
+ */
+
+/*
+ * Virtual connectors : reuse connector_init logic from
+ * drivers/gpu/drm/bridge/panel.c
+ */
+
+#include <drm/drmP.h>
+#include <drm/drm_atomic_helper.h>
+#include <drm/drm_crtc.h>
+#include <drm/drm_crtc_helper.h>
+#include "tidss_v_display.h"
+
+struct v_connector {
+	struct drm_connector base;
+	struct tidss_device *tidss;
+	int id;
+	struct drm_encoder *encoder;
+	struct drm_display_mode mode;
+};
+
+#define to_v_connector(x) container_of(x, struct v_connector, base)
+
+static int v_connector_get_modes(struct drm_connector *connector)
+{
+	struct v_connector *v_connector = to_v_connector(connector);
+	struct drm_device *dev = connector->dev;
+	struct drm_display_mode *mode;
+	const struct drm_display_mode *m = &v_connector->mode;
+
+	dev_dbg(connector->dev->dev, "%s\n", __func__);
+
+	mode = drm_mode_duplicate(dev, m);
+	if (!mode) {
+		dev_err(dev->dev, "failed to add mode %ux%u@%u\n",
+				m->hdisplay, m->vdisplay, m->vrefresh);
+		return 0;
+	}
+
+	mode->type |= (DRM_MODE_TYPE_DRIVER | DRM_MODE_TYPE_PREFERRED);
+
+	drm_mode_set_name(mode);
+
+	drm_mode_probed_add(connector, mode);
+
+	return 1;
+}
+
+static const struct drm_connector_helper_funcs v_connector_helper_funcs = {
+	.get_modes = v_connector_get_modes,
+};
+
+static void v_connector_destroy(struct drm_connector *connector)
+{
+	struct v_connector *v_connector = to_v_connector(connector);
+
+	dev_dbg(connector->dev->dev, "%s\n", __func__);
+
+	drm_connector_cleanup(connector);
+	kfree(v_connector);
+}
+
+static const struct drm_connector_funcs v_connector_funcs = {
+	.reset = drm_atomic_helper_connector_reset,
+	.fill_modes = drm_helper_probe_single_connector_modes,
+	.destroy = v_connector_destroy,
+	.atomic_duplicate_state = drm_atomic_helper_connector_duplicate_state,
+	.atomic_destroy_state = drm_atomic_helper_connector_destroy_state,
+};
+
+struct drm_connector *v_connector_init(struct tidss_device *tidss, int id,
+		struct drm_encoder *encoder, struct rpmsg_remotedev_display_disp *vp)
+{
+	struct drm_device *dev = tidss->ddev;
+	struct drm_connector *connector = NULL;
+	struct v_connector *v_connector;
+	unsigned int hfp, hbp, hsw, vfp, vbp, vsw;
+
+	v_connector = kzalloc(sizeof(struct v_connector), GFP_KERNEL);
+	if (!v_connector)
+		return NULL;
+
+	hfp = vp->width / 100;
+	if (!hfp)
+		hfp = 1;
+
+	hbp = hfp / 2;
+	if (!hbp)
+		hbp = 1;
+
+	hsw = hbp / 2;
+	if (!hsw)
+		hsw = 1;
+
+	vfp = vp->height / 100;
+	if (!vfp)
+		vfp = 1;
+
+	vbp = vfp / 2;
+	if (!vbp)
+		vbp = 1;
+
+	vsw = vbp / 2;
+	if (!vsw)
+		vsw = 1;
+
+	v_connector->tidss = tidss;
+
+	v_connector->mode.hdisplay = vp->width;
+	v_connector->mode.hsync_start = v_connector->mode.hdisplay + hfp;
+	v_connector->mode.hsync_end = v_connector->mode.hsync_start + hsw;
+	v_connector->mode.htotal = v_connector->mode.hsync_end + hbp;
+
+	v_connector->mode.vdisplay = vp->height;
+	v_connector->mode.vsync_start = v_connector->mode.vdisplay + vfp;
+	v_connector->mode.vsync_end = v_connector->mode.vsync_start + vsw;
+	v_connector->mode.vtotal = v_connector->mode.vsync_end + vbp;
+
+	v_connector->mode.vrefresh = vp->refresh;
+
+	v_connector->mode.clock = (v_connector->mode.vtotal * v_connector->mode.htotal * v_connector->mode.vrefresh) / 1000;
+
+	v_connector->encoder = encoder;
+	v_connector->id = id;
+
+	connector = &v_connector->base;
+
+	drm_connector_init(dev, connector, &v_connector_funcs,
+				DRM_MODE_CONNECTOR_VIRTUAL);
+	drm_connector_helper_add(connector, &v_connector_helper_funcs);
+
+	drm_connector_attach_encoder(connector, encoder);
+
+	return connector;
+}
+
+void v_connector_fini(struct tidss_device *tidss, struct drm_connector *connector)
+{
+	v_connector_destroy(connector);
+}
diff -Naur --no-dereference a/drivers/gpu/drm/tidss/tidss_v_crtc.c b/drivers/gpu/drm/tidss/tidss_v_crtc.c
--- a/drivers/gpu/drm/tidss/tidss_v_crtc.c	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/gpu/drm/tidss/tidss_v_crtc.c	2020-06-19 21:00:31.412227715 -0400
@@ -0,0 +1,488 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * Copyright (C) 2018 Texas Instruments Incorporated - http://www.ti.com/
+ * Author: Subhajit Paul <subhajit_paul@ti.com>
+ */
+
+/*
+ * Virtual crtcs: reuse drivers/gpu/drm/tidss/tidss_crtc.c
+ */
+
+#include <drm/drmP.h>
+#include <drm/drm_atomic.h>
+#include <drm/drm_atomic_helper.h>
+#include <drm/drm_plane.h>
+#include <drm/drm_crtc.h>
+#include <drm/drm_crtc_helper.h>
+#include <drm/drm_fb_cma_helper.h>
+#include <drm/drm_gem_cma_helper.h>
+#include "tidss_v_display.h"
+
+static DEFINE_MUTEX(out_buffers_lock);
+static LIST_HEAD(out_buffers_list);
+
+struct v_crtc {
+	struct drm_crtc base;
+	struct tidss_device *tidss;
+	int id;
+	unsigned int remote_id;
+
+	bool disable_in_progress;
+	bool enabled;
+	struct drm_pending_vblank_event *event;
+
+	struct mutex vsync_lock;
+
+	struct completion framedone_completion;
+	struct work_struct fake_vsync;
+
+};
+
+struct v_crtc_buffer_ref {
+	struct drm_framebuffer *fb;
+	atomic_t refcount;
+	struct list_head node;
+};
+
+#define to_v_crtc(x) container_of(x, struct v_crtc, base)
+
+static void v_crtc_finish_page_flip(struct drm_crtc *crtc)
+{
+	struct v_crtc *v_crtc = to_v_crtc(crtc);
+	struct drm_pending_vblank_event *event;
+	unsigned long flags;
+
+	spin_lock_irqsave(&crtc->dev->event_lock, flags);
+
+	event = v_crtc->event;
+	v_crtc->event = NULL;
+
+	if (!event) {
+		spin_unlock_irqrestore(&crtc->dev->event_lock, flags);
+		return;
+	}
+
+	drm_crtc_send_vblank_event(crtc, event);
+
+	spin_unlock_irqrestore(&crtc->dev->event_lock, flags);
+
+	drm_crtc_vblank_put(crtc);
+}
+
+static void v_crtc_vblank_irq(struct drm_crtc *crtc)
+{
+	struct v_crtc *v_crtc = to_v_crtc(crtc);
+
+	drm_crtc_handle_vblank(crtc);
+
+	v_crtc_finish_page_flip(crtc);
+
+	mutex_lock(&v_crtc->vsync_lock);
+	if (v_crtc->disable_in_progress) {
+		v_crtc->disable_in_progress = false;
+		complete(&v_crtc->framedone_completion);
+	}
+	mutex_unlock(&v_crtc->vsync_lock);
+
+}
+
+void v_crtc_commit_done(struct rpmsg_remotedev_display_commit *commit, void *data)
+{
+	struct drm_crtc *crtc = commit->priv;
+
+	v_crtc_vblank_irq(crtc);
+
+	kfree(commit);
+}
+
+void v_crtc_buffer_done(struct rpmsg_remotedev_display_buffer *buffer, void *data)
+{
+	struct v_crtc_buffer_ref *ref = buffer->priv;
+
+	mutex_lock(&out_buffers_lock);
+	if (atomic_dec_and_test(&ref->refcount)) {
+		list_del(&ref->node);
+		kfree(ref);
+		// TODO release the fence here
+	}
+	mutex_unlock(&out_buffers_lock);
+
+	kfree(buffer);
+}
+
+static void fake_vsync_fn(struct work_struct *work)
+{
+	struct v_crtc *v_crtc = container_of(work, struct v_crtc, fake_vsync);
+	struct drm_crtc *crtc = &v_crtc->base;
+
+	v_crtc_vblank_irq(crtc);
+}
+
+
+static u32 v_crtc_update_plane_mask(struct drm_crtc *crtc, struct drm_crtc_state *old, struct drm_crtc_state *new)
+{
+	struct drm_plane *plane;
+	u32 update_plane_mask = 0;
+	u32 cont_u_planes = 0;
+	u32 new_planes = ~old->plane_mask & new->plane_mask;
+	u32 old_planes = ~new->plane_mask & old->plane_mask;
+	u32 cont_planes = old->plane_mask & new->plane_mask;
+
+	drm_for_each_plane_mask(plane, crtc->dev, cont_planes)
+		if (v_plane_update_needed(plane))
+			cont_u_planes |= (1 << drm_plane_index(plane));
+
+
+	update_plane_mask = new_planes | old_planes | cont_u_planes;
+
+	return update_plane_mask;
+}
+
+static struct rpmsg_remotedev_display_buffer *v_crtc_buffer_alloc_for_req(struct drm_crtc *crtc, struct drm_framebuffer *fb,
+		struct drm_plane_state *pstate)
+{
+	struct v_crtc *v_crtc = to_v_crtc(crtc);
+	struct rpmsg_remotedev_display_buffer *buffer;
+	struct v_crtc_buffer_ref *ref, *buffer_ref = NULL;
+	int cnt;
+
+	buffer = kzalloc(sizeof(*buffer), GFP_KERNEL);
+	if (!buffer)
+		return NULL;
+
+
+	mutex_lock(&out_buffers_lock);
+	list_for_each_entry(ref, &out_buffers_list, node) {
+		if (ref->fb == fb) {
+			atomic_inc(&ref->refcount);
+			buffer_ref = ref;
+			break;
+		}
+	}
+	if (buffer_ref)
+		goto found;
+
+	buffer_ref = kzalloc(sizeof(*buffer_ref), GFP_KERNEL);
+	if (!buffer_ref) {
+		mutex_unlock(&out_buffers_lock);
+		return NULL;
+	}
+	buffer_ref->fb = fb;
+	atomic_set(&buffer_ref->refcount, 1);
+	// TODO acquire fence here
+	list_add(&buffer_ref->node, &out_buffers_list);
+
+found:
+	mutex_unlock(&out_buffers_lock);
+
+	buffer->width = pstate->src_w >> 16;
+	buffer->height = pstate->src_h >> 16;
+	buffer->format = fb->format->format;
+	buffer->num_planes = min_t(u32, fb->format->num_planes, RPMSG_REMOTEDEV_DISPLAY_MAX_PLANES);
+	WARN_ON(buffer->num_planes != fb->format->num_planes);
+
+	for (cnt = 0; cnt < buffer->num_planes; cnt++) {
+		struct drm_gem_cma_object *gem;
+
+		gem = drm_fb_cma_get_gem_obj(fb, cnt);
+		buffer->planes[cnt] = gem->paddr + fb->offsets[cnt] +
+			(pstate->src_x >> 16) * fb->format->cpp[cnt] +
+			(pstate->src_y >> 16) * fb->pitches[cnt];
+		buffer->pitches[cnt] = fb->pitches[cnt];
+	}
+
+	buffer->rdev = v_crtc->tidss->rdev;
+	buffer->priv = buffer_ref;
+
+	return buffer;
+}
+
+static bool v_crtc_plane_state_to_vid_update_info(struct drm_crtc *crtc, struct drm_plane *plane,
+		struct rpmsg_remotedev_display_pipe_update *vid)
+{
+	struct drm_plane_state *pstate;
+
+	if (WARN_ON(!plane || !plane->state))
+		return false;
+
+	pstate = plane->state;
+
+	vid->pipe_id = v_plane_get_remote_id(plane);
+
+	if (!pstate->fb) {
+		vid->enabled = false;
+		dev_dbg(plane->dev->dev, "%s: disabling plane 0x%x\n", __func__, v_plane_get_remote_id(plane));
+	} else {
+		struct drm_framebuffer *fb = pstate->fb;
+		struct rpmsg_remotedev_display_buffer *buffer;
+
+		buffer = v_crtc_buffer_alloc_for_req(crtc, fb, pstate);
+		if (!buffer) {
+			dev_err(plane->dev->dev, "%s: could not allocate buffer\n", __func__);
+			return false;
+		}
+
+		if (WARN_ON(!fb->format))
+			return false;
+
+		vid->enabled = true;
+		vid->dst_w = pstate->crtc_w;
+		vid->dst_h = pstate->crtc_h;
+		vid->dst_x = pstate->crtc_x;
+		vid->dst_y = pstate->crtc_y;
+
+		vid->buffer = buffer;
+		dev_dbg(plane->dev->dev, "%s: updating plane 0x%x\n", __func__, v_plane_get_remote_id(plane));
+
+	}
+
+	return true;
+}
+
+
+static void v_crtc_flush_to_remote(struct drm_crtc *crtc, u32 planes, char *stage)
+{
+	struct v_crtc *v_crtc = to_v_crtc(crtc);
+	struct drm_plane *plane;
+	int i = 0;
+	struct rpmsg_remotedev_display_commit *commit;
+
+	if (!planes)
+		return;
+
+	commit = kzalloc(sizeof(*commit), GFP_KERNEL);
+	if (!commit)
+		return;
+
+	dev_dbg(crtc->dev->dev, "%s: flushing out vp in %s = 0x%x\n", __func__, stage, v_crtc->remote_id);
+	drm_for_each_plane_mask(plane, crtc->dev, planes) {
+		bool ret;
+
+		if (WARN_ON(i >= RPMSG_REMOTEDEV_DISPLAY_MAX_PIPES))
+			continue;
+		ret = v_crtc_plane_state_to_vid_update_info(crtc, plane, &commit->pipes[i]);
+		if (!ret) {
+			dev_err(crtc->dev->dev, "%s: error creating vid commit req [%d]\n", __func__, i);
+			return;
+		}
+		i++;
+	}
+
+	commit->disp_id = v_crtc->remote_id;
+	commit->num_pipe_updates = i;
+	commit->priv = crtc;
+	commit->rdev = v_crtc->tidss->rdev;
+
+	v_crtc->tidss->rdev->device.display.ops->commit(v_crtc->tidss->rdev, commit);
+}
+
+static int v_crtc_atomic_check(struct drm_crtc *crtc, struct drm_crtc_state *state)
+{
+	dev_dbg(crtc->dev->dev, "%s\n", __func__);
+
+	return 0;
+}
+
+static void v_crtc_atomic_begin(struct drm_crtc *crtc, struct drm_crtc_state *old_crtc_state)
+{
+	dev_dbg(crtc->dev->dev, "%s\n", __func__);
+}
+
+static enum drm_mode_status v_crtc_mode_valid(struct drm_crtc *crtc,
+					   const struct drm_display_mode *mode)
+{
+	dev_dbg(crtc->dev->dev, "%s\n", __func__);
+
+	return MODE_OK;
+}
+
+static void v_crtc_atomic_enable(struct drm_crtc *crtc,
+				     struct drm_crtc_state *old_state)
+{
+	struct v_crtc *v_crtc = to_v_crtc(crtc);
+	u32 upd_planes;
+
+	dev_dbg(crtc->dev->dev, "%s\n", __func__);
+
+	WARN_ON(!crtc->state->event);
+
+	/* Turn vertical blanking interrupt reporting on. */
+	drm_crtc_vblank_on(crtc);
+	WARN_ON(drm_crtc_vblank_get(crtc) != 0);
+	v_crtc->enabled = true;
+
+	spin_lock_irq(&crtc->dev->event_lock);
+	if (crtc->state->event) {
+		v_crtc->event = crtc->state->event;
+		crtc->state->event = NULL;
+	}
+	spin_unlock_irq(&crtc->dev->event_lock);
+
+	upd_planes = v_crtc_update_plane_mask(crtc, old_state, crtc->state);
+	if (upd_planes)
+		v_crtc_flush_to_remote(crtc, upd_planes, "enable");
+	else
+		schedule_work(&v_crtc->fake_vsync);
+}
+
+static void v_crtc_atomic_disable(struct drm_crtc *crtc,
+				      struct drm_crtc_state *old_state)
+{
+	struct v_crtc *v_crtc = to_v_crtc(crtc);
+	u32 upd_planes;
+
+	dev_dbg(crtc->dev->dev, "%s\n", __func__);
+
+	reinit_completion(&v_crtc->framedone_completion);
+
+	WARN_ON(!crtc->state->event);
+
+	WARN_ON(drm_crtc_vblank_get(crtc) != 0);
+
+	mutex_lock(&v_crtc->vsync_lock);
+	v_crtc->disable_in_progress = true;
+	mutex_unlock(&v_crtc->vsync_lock);
+
+	spin_lock_irq(&crtc->dev->event_lock);
+	if (crtc->state->event) {
+		v_crtc->event = crtc->state->event;
+		crtc->state->event = NULL;
+	}
+	spin_unlock_irq(&crtc->dev->event_lock);
+
+	upd_planes = v_crtc_update_plane_mask(crtc, old_state, crtc->state);
+	if (upd_planes)
+		v_crtc_flush_to_remote(crtc, upd_planes, "disable");
+	else
+		schedule_work(&v_crtc->fake_vsync);
+
+	if (!wait_for_completion_timeout(&v_crtc->framedone_completion,
+					 msecs_to_jiffies(500)))
+		dev_err(crtc->dev->dev, "Timeout waiting for disable complete on v_crtc %d",
+			v_crtc->remote_id);
+
+	v_crtc->enabled = false;
+	drm_crtc_vblank_off(crtc);
+}
+
+
+static void v_crtc_atomic_flush(struct drm_crtc *crtc,
+				    struct drm_crtc_state *old_crtc_state)
+{
+	struct v_crtc *v_crtc = to_v_crtc(crtc);
+	u32 upd_planes;
+
+	dev_dbg(crtc->dev->dev, "%s\n", __func__);
+
+	/* Only flush the CRTC if it is currently enabled. */
+	if (!v_crtc->enabled)
+		return;
+
+	/* TODO : check if the old frame is still there */
+
+	// I think we always need the event to signal flip done
+	WARN_ON(!crtc->state->event);
+
+	WARN_ON(drm_crtc_vblank_get(crtc) != 0);
+
+	spin_lock_irq(&crtc->dev->event_lock);
+
+	if (crtc->state->event) {
+		v_crtc->event = crtc->state->event;
+		crtc->state->event = NULL;
+	}
+
+	spin_unlock_irq(&crtc->dev->event_lock);
+
+	upd_planes = v_crtc_update_plane_mask(crtc, old_crtc_state, crtc->state);
+	if (upd_planes)
+		v_crtc_flush_to_remote(crtc, upd_planes, "flush");
+	else
+		schedule_work(&v_crtc->fake_vsync);
+}
+
+
+static const struct drm_crtc_helper_funcs v_crtc_helper_funcs = {
+	.atomic_check = v_crtc_atomic_check,
+	.atomic_begin = v_crtc_atomic_begin,
+	.atomic_flush = v_crtc_atomic_flush,
+	.atomic_enable = v_crtc_atomic_enable,
+	.atomic_disable = v_crtc_atomic_disable,
+
+	.mode_valid = v_crtc_mode_valid,
+};
+
+static void v_crtc_destroy(struct drm_crtc *crtc)
+{
+	struct v_crtc *v_crtc = to_v_crtc(crtc);
+
+	dev_dbg(crtc->dev->dev, "%s\n", __func__);
+
+	drm_crtc_cleanup(crtc);
+	kfree(v_crtc);
+}
+
+static int v_crtc_enable_vblank(struct drm_crtc *crtc)
+{
+	dev_dbg(crtc->dev->dev, "%s\n", __func__);
+
+	return 0;
+}
+
+static void v_crtc_disable_vblank(struct drm_crtc *crtc)
+{
+	dev_dbg(crtc->dev->dev, "%s\n", __func__);
+}
+
+static const struct drm_crtc_funcs v_crtc_funcs = {
+	.reset = drm_atomic_helper_crtc_reset,
+	.destroy = v_crtc_destroy,
+	.set_config = drm_atomic_helper_set_config,
+	.page_flip = drm_atomic_helper_page_flip,
+	.atomic_duplicate_state = drm_atomic_helper_crtc_duplicate_state,
+	.atomic_destroy_state = drm_atomic_helper_crtc_destroy_state,
+	.enable_vblank = v_crtc_enable_vblank,
+	.disable_vblank = v_crtc_disable_vblank,
+};
+
+struct drm_crtc *v_crtc_init(struct tidss_device *tidss, int id,
+		struct drm_plane *plane, struct rpmsg_remotedev_display_disp *vp)
+{
+	struct drm_device *dev = tidss->ddev;
+	struct drm_crtc *crtc = NULL;
+	struct v_crtc *v_crtc;
+	int ret;
+
+	v_crtc = kzalloc(sizeof(*v_crtc), GFP_KERNEL);
+	if (!v_crtc)
+		return NULL;
+
+	v_crtc->tidss = tidss;
+	v_crtc->id = id;
+	v_crtc->remote_id = vp->disp_id;
+	init_completion(&v_crtc->framedone_completion);
+	INIT_WORK(&v_crtc->fake_vsync, fake_vsync_fn);
+
+	mutex_init(&v_crtc->vsync_lock);
+
+	crtc = &v_crtc->base;
+
+	ret = drm_crtc_init_with_planes(dev, crtc, plane, NULL,
+					&v_crtc_funcs, "crtc-0x%x", id);
+	if (ret < 0)
+		goto err;
+
+	drm_crtc_helper_add(crtc, &v_crtc_helper_funcs);
+
+	return crtc;
+
+err:
+	kfree(v_crtc);
+	return NULL;
+}
+
+void v_crtc_fini(struct tidss_device *tidss, struct drm_crtc *crtc)
+{
+	v_crtc_destroy(crtc);
+}
+
diff -Naur --no-dereference a/drivers/gpu/drm/tidss/tidss_v_display.h b/drivers/gpu/drm/tidss/tidss_v_display.h
--- a/drivers/gpu/drm/tidss/tidss_v_display.h	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/gpu/drm/tidss/tidss_v_display.h	2020-06-19 21:00:31.412227715 -0400
@@ -0,0 +1,31 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+/*
+ * Copyright (C) 2018 Texas Instruments Incorporated - http://www.ti.com/
+ * Author: Subhajit Paul <subhajit_paul@ti.com>
+ */
+
+#ifndef __TIDSS_V_DISPLAY_H__
+#define __TIDSS_V_DISPLAY_H__
+
+#include "tidss_drv.h"
+
+struct drm_encoder *v_encoder_init(struct tidss_device *tidss, int id,
+		int crtc_mask, struct rpmsg_remotedev_display_disp *vp);
+struct drm_connector *v_connector_init(struct tidss_device *tidss, int id,
+		struct drm_encoder *encoder, struct rpmsg_remotedev_display_disp *vp);
+struct drm_plane *v_plane_init(struct tidss_device *tidss, int id,
+		int crtc_bitmask, enum drm_plane_type type, struct rpmsg_remotedev_display_disp *vp, int index);
+struct drm_crtc *v_crtc_init(struct tidss_device *tidss, int id,
+		struct drm_plane *plane, struct rpmsg_remotedev_display_disp *vp);
+
+void v_crtc_fini(struct tidss_device *tidss, struct drm_crtc *crtc);
+void v_plane_fini(struct tidss_device *tidss, struct drm_plane *plane);
+void v_connector_fini(struct tidss_device *tidss, struct drm_connector *connector);
+void v_encoder_fini(struct tidss_device *tidss, struct drm_encoder *encoder);
+
+unsigned int v_plane_get_remote_id(struct drm_plane *plane);
+bool v_plane_update_needed(struct drm_plane *plane);
+
+void v_crtc_commit_done(struct rpmsg_remotedev_display_commit *commit, void *data);
+void v_crtc_buffer_done(struct rpmsg_remotedev_display_buffer *buffer, void *data);
+#endif
diff -Naur --no-dereference a/drivers/gpu/drm/tidss/tidss_v_encoder.c b/drivers/gpu/drm/tidss/tidss_v_encoder.c
--- a/drivers/gpu/drm/tidss/tidss_v_encoder.c	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/gpu/drm/tidss/tidss_v_encoder.c	2020-06-19 21:00:31.412227715 -0400
@@ -0,0 +1,101 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * Copyright (C) 2018 Texas Instruments Incorporated - http://www.ti.com/
+ * Author: Subhajit Paul <subhajit_paul@ti.com>
+ */
+
+/*
+ * Virtual encoders : reuse drivers/gpu/drm/tidss/tidss_encoder.c
+ */
+
+#include <drm/drmP.h>
+#include <drm/drm_atomic_helper.h>
+#include <drm/drm_crtc.h>
+#include <drm/drm_crtc_helper.h>
+#include "tidss_v_display.h"
+
+struct v_encoder {
+	struct drm_encoder base;
+	struct tidss_device *tidss;
+	int id;
+	int possible_crtcs;
+};
+
+#define to_v_encoder(x) container_of(x, struct v_encoder, base)
+
+static void v_encoder_disable(struct drm_encoder *encoder)
+{
+	dev_dbg(encoder->dev->dev, "%s\n", __func__);
+}
+
+static void v_encoder_enable(struct drm_encoder *encoder)
+{
+	dev_dbg(encoder->dev->dev, "%s\n", __func__);
+}
+
+static int v_encoder_atomic_check(struct drm_encoder *encoder,
+				      struct drm_crtc_state *crtc_state,
+				      struct drm_connector_state *conn_state)
+{
+	dev_dbg(encoder->dev->dev, "%s\n", __func__);
+
+	return 0;
+}
+
+static void v_encoder_atomic_mode_set(struct drm_encoder *encoder,
+				   struct drm_crtc_state *crtc_state,
+				   struct drm_connector_state *conn_state)
+{
+	dev_dbg(encoder->dev->dev, "%s\n", __func__);
+}
+
+static const struct drm_encoder_helper_funcs v_encoder_helper_funcs = {
+	.atomic_mode_set = v_encoder_atomic_mode_set,
+	.disable = v_encoder_disable,
+	.enable = v_encoder_enable,
+	.atomic_check = v_encoder_atomic_check,
+};
+
+static void v_encoder_destroy(struct drm_encoder *encoder)
+{
+	struct v_encoder *v_encoder = to_v_encoder(encoder);
+
+	dev_dbg(encoder->dev->dev, "%s\n", __func__);
+
+	drm_encoder_cleanup(encoder);
+	kfree(v_encoder);
+}
+
+static const struct drm_encoder_funcs v_encoder_funcs = {
+	.destroy = v_encoder_destroy,
+};
+
+struct drm_encoder *v_encoder_init(struct tidss_device *tidss, int id, int crtc_mask,
+		struct rpmsg_remotedev_display_disp *vp)
+{
+	struct drm_device *dev = tidss->ddev;
+	struct drm_encoder *encoder = NULL;
+	struct v_encoder *v_encoder;
+
+	v_encoder = kzalloc(sizeof(*v_encoder), GFP_KERNEL);
+	if (!v_encoder)
+		return NULL;
+
+	v_encoder->tidss = tidss;
+	v_encoder->id = id;
+	v_encoder->possible_crtcs = crtc_mask;
+
+	encoder = &v_encoder->base;
+	encoder->possible_crtcs = crtc_mask;
+
+	drm_encoder_init(dev, encoder, &v_encoder_funcs,
+			 DRM_MODE_ENCODER_VIRTUAL, "encoder-0x%x", id);
+	drm_encoder_helper_add(encoder, &v_encoder_helper_funcs);
+
+	return encoder;
+}
+
+void v_encoder_fini(struct tidss_device *tidss, struct drm_encoder *encoder)
+{
+	v_encoder_destroy(encoder);
+}
